
#include <SoftwareSerial.h>
#include "eGizmo_PBot_Uno.h"
#include <Wire.h>
char data = 0;
SoftwareSerial mySerial(0, 1); // TX, RX
//Grip Range
#define minGrip  90
#define maxGrip 135

//Base Range
#define minBase  0
#define maxBase 160

//Tuck Range
#define minTuck  40
#define maxTuck 140

//Lift Range
#define minLift  40
#define maxLift 160

//HOME
#define homeGrip 100 //135
#define homeLift 50  //40
#define homeTuck 60
#define homeBase 90


//SERVO NUMBERS
#define GRIP 1
#define BASE 2
#define LIFT 3
#define TUCK 4

int Grip_hopAngle = 15;
int Base_hopAngle = 10;
int Lift_hopAngle = 8;
int Tuck_hopAngle = 8;

int MotorSpeed = 80; //Set Speeds to 120 PWM
int delaymsec = 2000;

eGizmo_PBot_Uno PBot;


void setup() {
  Serial.begin(9600);
  mySerial.begin(9600);
  PBot.BEGIN();
  pinMode(4, OUTPUT);
  PBot.STOP();
  //Set all servo  to home position
  PBot.SERVO1(homeGrip);
  delay(15);
  PBot.SERVO2(homeBase);
  delay(15);
  PBot.SERVO3(homeLift);
  delay(15);
  PBot.SERVO4(homeTuck);
  delay(15);
  //Save position values
  PBot.servo1Pos = homeGrip;
  PBot.servo2Pos = homeBase;
  PBot.servo3Pos = homeLift;
  PBot.servo4Pos = homeTuck;
}
void loop() {
  Bluetooth();
}


void Bluetooth() {
  if (mySerial.available() > 0)
  {
    data = mySerial.read();
    Serial.print(data);
    //Serial.print("\n");
    Serial.println();
    if (data == '0')
    {

    }
    else if (data == '1')
    {

    }
    else if (data == '2')
    {

    }
    else if (data == '3')
    {

    }
    else if (data == '4')
    {

    }
    else if (data == '5')
    {

    }
    else if (data == '6')
    {

    }
    else if (data == '7')
    {

    }
    else if (data == '8')
    {

    }
    else if (data == '9')
    {

    }
    else if (data == 'B')
    {

    }
    else if (data == 'C') //GRIP
    {
      PBot.servo1Pos--;
      PBot.servo1Pos = constrain(PBot.servo1Pos, minGrip, maxGrip);
      Serial.println(PBot.servo1Pos);
      //Write servo position values
      PBot.SERVO1(PBot.servo1Pos - Grip_hopAngle);
    }
    else if (data == 'D') //GRIP
    {
      PBot.servo1Pos++;

      //Keep Values within acceptable limits
      PBot.servo1Pos = constrain(PBot.servo1Pos, minGrip, maxGrip);
      Serial.println(PBot.servo1Pos);

      //Write servo position values
      PBot.SERVO1(PBot.servo1Pos + Grip_hopAngle);

    }
    else if (data == 'E') // LIFT UP
    {
      PBot.servo3Pos--;

      //Keep Values within acceptable limits
      PBot.servo3Pos = constrain(PBot.servo3Pos, minLift, maxLift);
      Serial.println(PBot.servo3Pos);

      //Write servo position values
      PBot.SERVO3(PBot.servo3Pos - Lift_hopAngle);
    }
    else if (data == 'F') // LIFT DOWN
    {
      PBot.servo3Pos++;

      //Keep Values within acceptable limits
      PBot.servo3Pos = constrain(PBot.servo3Pos, minLift, maxLift);
      Serial.println(PBot.servo3Pos);

      //Write servo position values
      PBot.SERVO3(PBot.servo3Pos + Lift_hopAngle);
    }
    else if (data == 'G')
    {

    }
    else if (data == 'H')
    {

    }
    else if (data == 'I')
    {
      //Move Forward
      PBot.FORWARD(MotorSpeed);
      //delay(delaymsec);
      //digitalWrite(4, HIGH); delay(1000);
      //digitalWrite(4, LOW); delay(1000);
      // PBot.STOP();
    }
    else if (data == 'J')
    {
      //Reverse
      PBot.REVERSE(MotorSpeed);
      //delay(delaymsec);
      // PBot.STOP();
    }
    else if (data == 'K')
    {
      //Extreme Left/SpinLeft
      PBot.SPINLEFT(MotorSpeed);
      // delay(delaymsec);
      //PBot.STOP();
    }
    else if (data == 'L')
    {
      //Extreme Right/SpinRight
      PBot.SPINRIGHT(MotorSpeed);
      // delay(delaymsec);
      //PBot.STOP();
    }
    else if (data == 'M') //BASE TURNRIGHT
    {
      PBot.servo2Pos++;

      //Keep Values within acceptable limits
      PBot.servo2Pos = constrain(PBot.servo2Pos, minBase, maxBase);
      Serial.println(PBot.servo2Pos);

      //Write servo position values
      PBot.SERVO2(PBot.servo2Pos + Base_hopAngle);
    }
    else if (data == 'N') // TUCK UP
    {
      PBot.servo4Pos++;

      //Keep Values within acceptable limits
      PBot.servo4Pos = constrain(PBot.servo4Pos, minTuck, maxTuck);
      Serial.println(PBot.servo4Pos);

      //Write servo position values
      PBot.SERVO4(PBot.servo4Pos + Tuck_hopAngle);
    }
    else if (data == 'O') //BASE TURNLEFT
    {
      PBot.servo2Pos--;

      //Keep Values within acceptable limits
      PBot.servo2Pos = constrain(PBot.servo2Pos, minBase, maxBase);
      Serial.println(PBot.servo2Pos);

      //Write servo position values
      PBot.SERVO2(PBot.servo2Pos - Tuck_hopAngle);
    }
    else if (data == 'P') //TUCK DOWN
    {
      PBot.servo4Pos--;

      //Keep Values within acceptable limits
      PBot.servo4Pos = constrain(PBot.servo4Pos, minTuck, maxTuck);
      Serial.println(PBot.servo4Pos);

      //Write servo position values
      PBot.SERVO4(PBot.servo4Pos - Tuck_hopAngle);
    }
    else if (data == 'Q')
    {

    }
    else if (data == 'R')
    {

    }
    else if (data == 'S')
    {
      PBot.STOP();
    }
    else if (data == 's')
    {
      //PBot.STOP();
    }
  }
}


